﻿XIncludeFile "showinfo.pbi"

UseJPEGImageDecoder()

EnableExplicit

DataSection
  ; logo schrift gentium 32 pixel größe, schatten, 2 pixel umrandung
Logo:
  IncludeBinary "systeminfo.jpg"
LogoEnd:
  Data.l 0
EndDataSection

Global LogoID.i, InfoFileID.i
Global GTK2Version$, GTK3Version$
Global PackageManager$
Define InputSource.i, Done.i, RunResult.i
Define Result.i, LineNum.i, FileStatus.i
Define Line$, TokenField$, ValueField$, InstallDir$,  Textmode$
Define quitMainForm.i = 0
Define EventID.i, MenuID.i, GadgetID.i, WindowID.i
Define EVType.i

XIncludeFile "MainWindow.pbf"
XIncludeFile "SystemInfo.pbi"

Procedure GuiClient_Init()
  Define BGColor.i
  
  PackageManager$ = ""
  
  SetGadgetState(#LogoImage, LogoID)
  
  SetGadgetText(#Fieldtoken1, "Name")
  SetGadgetText(#Fieldtoken2, "Version")
  SetGadgetText(#Fieldtoken3, "ID")
  SetGadgetText(#Fieldtoken4, "Like")
  SetGadgetText(#Fieldtoken5, "Pretty Name")
  SetGadgetText(#Fieldtoken6, "URL")
  SetGadgetText(#Fieldtoken7, "Code Name")
  SetGadgetText(#Fieldtoken8, "Package Manager")
  SetGadgetText(#Fieldtoken9, "Public IP")
  SetGadgetText(#Fieldtoken10, "GTK2 Version")
  SetGadgetText(#Fieldtoken11, "GTK3 Version")
  SetGadgetText(#Fieldtoken12, "QT Version")
  SetGadgetText(#Fieldtoken13, "Version ID")
  
  BGColor = RGB($80, $80, $80)
  SetGadgetColor(#Fieldtoken2, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldValue2, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldToken4, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldValue4, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldToken6, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#HomepageURL, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldToken8, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldValue8, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldToken10, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldValue10, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldToken12, #PB_Gadget_BackColor, BGColor)
  SetGadgetColor(#FieldValue12, #PB_Gadget_BackColor, BGColor)
  
  SetGadgetAttribute(#MemoryBar, #PB_ProgressBar_Minimum, 0)
  SetGadgetAttribute(#MemoryBar, #PB_ProgressBar_Maximum, 100)
  SetGadgetState(#MemoryBar, 30)
;   GadgetToolTip(#Gadget_MainForm_EditorCPU, "lshw -C cpu")
;   GadgetToolTip(#Gadget_MainForm_EditorChipset, "lshw -C pci")  ; + -C chipset
;   GadgetToolTip(#Gadget_MainForm_EditorMemory, "lshw -C storage")
;   GadgetToolTip(#Gadget_MainForm_EditorDrives, "lshw -C ide") ; -C scsi. -C storage
;   GadgetToolTip(#Gadget_MainForm_EditorIO, "lshw -C usb")
; ;  GadgetToolTip(#Gadget_MainForm_EditorGPU, "")
;   GadgetToolTip(  #Gadget_MainForm_EditorNetwork, "lshw -C network")
;   GadgetToolTip(#Gadget_MainForm_EditorDisplay, "lshw -C display")
  
  SetGadgetFont(#HomepageURL, FontID(#Font_Window_0_0))
  
EndProcedure

Procedure.s GetOutput(ProgramName$, Parameter$, *ExitCode, SkipLines.i = 0)
  Define ThisTool.i, ExitCode.i, LineNum.i
  Define ASCIIOutput$, UTFOutput$, NextLine$
  
  ThisTool = RunProgram(ProgramName$, Parameter$, GetCurrentDirectory(), #PB_Program_Open | #PB_Program_Read | #PB_Program_Ascii | #PB_Program_Hide)
  
  UTFOutput$ = ""
  ASCIIOutput$ = ""
  LineNum = 1
  If (ThisTool <> 0)
    While ProgramRunning(ThisTool)
      If AvailableProgramOutput(ThisTool)
        NextLine$ = ReadProgramString(ThisTool)
        If (SkipLines < LineNum)
          If (ASCIIOutput$ <> "")
            ASCIIOutput$ + Chr(13)
          EndIf
          
          ASCIIOutput$ + NextLine$
        EndIf
        
        Linenum + 1
      EndIf
      
    Wend
    ExitCode = ProgramExitCode(ThisTool)
    CloseProgram(ThisTool)
    
    If (*ExitCode <> 0)
      PokeI(*ExitCode, ExitCode)
    EndIf
    
    UTFOutput$ = ASCIIOutput$ ; PeekS(@ASCIIOutput$, -1, #PB_Ascii)
    
  Else
    If (*ExitCode <> 0)
      PokeI(*ExitCode, ThisTool)
    EndIf
  EndIf
  
  ProcedureReturn UTFOutput$
  
EndProcedure

Procedure.s GrabVersionNumber(Output$)
  Define Position1.i, Position2.i
  Define Version$
  
  Version$ = "unknown"
  Position1 = FindString(Output$, "Installed Packages")
  Position2 = FindString(Output$, "Available Packages")
  
  If ((Position1 > 0) And (Position2 > 0))
    Position1 = FindString(Output$, "Version", Position1, #PB_String_NoCase)
    If (Position1 > 0)
      Position1 = FindString(Output$, ": ", Position1)
      Position2 = FindString(Output$, Chr(13), Position1)
      If ((Position1 > 0) And (Position2 > 0))
        Version$ = Mid(Output$, Position1 + 2, Position2 - Position1 - 2)
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn Version$
  
EndProcedure

Procedure.s GetNextLine(Text$, StartPosition.i, *NextStartPosition)
  Define f.i
  Define EndPosition.i, NLen.i
  Define c$, NextLine$
  
  If (*NextStartPosition = 0)
    Debug "error - passed nextposition pointer should not be zero!"
    ProcedureReturn ""
  EndIf
  
  EndPosition = FindString(Text$, Chr(13), StartPosition)
  
  PokeI(*NextStartPosition, EndPosition + 1)
  
  NextLine$ = Mid(Text$, StartPosition, EndPosition - StartPosition)
  
;   NLen = Len(NextLine$)
;   Debug Str(Len(NextLine$))
;   
;   For f = 1 To NLen
;     c$ = Mid(text$, StartPosition, 1)
;     Debug Str(f) + " = " + c$ + " -> " + Str(Val(c$))
;   Next
  
  ProcedureReturn NextLine$
  
EndProcedure
  
Procedure.i FillHardwareTabs()
  Define f.i, Done.i
  Define ExitCode.i, StartInfo.i
  Define EndOfLine.i, OutputLength.i
  Define c$, NextLine$, FindeMich$
  Define Output$, LSHWPath$, GlxInfoPath$, GPUInfo$
  
  ; gpu info
  ; glxinfo from mesa utilities (apt-get install mesa-utils)
  
  GlxInfoPath$ = GetOutput(#SystemInfo_Which, "glxinfo", @ExitCode)
  
  If (GlxInfoPath$ =  "")
    Output$ = "please install 'glxinfo' to see this information (for example for debian based distributions do 'apt-get install mesa-utils')"
    SetGadgetText(#EditorGPU, Output$)
  Else
    GPUInfo$ = ""
    Output$ = GetOutput(GlxInfoPath$, "", @ExitCode)
    OutputLength = Len(Output$)
    StartInfo = FindString(Output$, "Extended renderer info", 1, #PB_String_NoCase)
    If (StartInfo > 0)
      FindeMich$ = "   "
      StartInfo = FindString(Output$, FindeMich$, StartInfo)
      If (StartInfo <> 0)
        StartInfo + 1
        Done = 0
        Repeat
;          Debug "Startinfo pre = " + Str(StartInfo)
          NextLine$ = GetNextLine(Output$, StartInfo, @StartInfo)
;          Debug "Startinfo post = " + Str(StartInfo)
;          Debug "NL = '" + NextLine$ + "'"
          
          c$ = Left(NextLine$, 3)
          If (c$ = "   ")
            EndOfLine = FindString(Output$, Chr(13), StartInfo)
            If (EndOfLine <> 0)
;              Debug "NL2 = '" + NextLine$ + "'"
             
              If (Left(NextLine$, 3) <> "   ")
                Done = 1
                Break
              Else
                NextLine$ = LTrim(NextLine$)
                
                If (GPUInfo$ <> "")
                  GPUInfo$ + Chr(13)
                EndIf
                
                GPUInfo$ + NextLine$
              EndIf
            EndIf
          Else
            Break
          EndIf
        Until (Done <> 0)
      EndIf
    Else 
      GPUInfo$ = "could'nt locate the GPU information from your glxinfo output" + Chr(13) + "please send a bugreport including the version information about your linux distribution, platform and the version of your glxinfo via mail to fhaber@gmx.net"
    EndIf
    SetGadgetText(#EditorGPU, GPUInfo$)
  EndIf
  
  LSHWPath$ = GetOutput("/usr/bin/which", "lshw", @ExitCode)
  If (LSHWPath$ = "")
    Output$ = "please install 'lshw' to see this information"
    SetGadgetText(#EditorCPU, Output$)
    SetGadgetText(#EditorIO, Output$)
    SetGadgetText(#EditorChipset, Output$)
    SetGadgetText(#EditorDisplay, Output$)
    SetGadgetText(#EditorDrives, Output$)
    SetGadgetText(#EditorNetwork, Output$)
    ProcedureReturn -1
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C cpu", @ExitCode, 1)
  If (Output$ <> "")
    SetGadgetText(#EditorCPU, Output$)
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C bridge", @ExitCode, 1)
  If (Output$ <> "")
    SetGadgetText(#EditorIO, Output$)
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C bridge", @ExitCode, 1)
  If (Output$ <> "")
    SetGadgetText(#EditorChipset, Output$)
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C display", @ExitCode, 1)
  If (Output$ <> "")
    SetGadgetText(#EditorDisplay, Output$)
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C storage", @ExitCode, 1)
  If (Output$ <> "")
    SetGadgetText(#EditorDrives, Output$)
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C memory", @ExitCode, 1)
  Output$ + Chr(13) + GetOutput("/usr/bin/free", "", @ExitCode)
; this doesnt work because /proc are virtual files and have a size of 0  
;   If (FileSize("/proc/meminfo") > 0)
;     Output$ + Chr(13) + GetOutput("/proc/meminfo", "", @ExitCode)
;   EndIf
  If (Output$ <> "")
    SetGadgetText(#EditorMemory, Output$)
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C network", @ExitCode, 1)
  If (Output$ <> "")
    SetGadgetText(#EditorNetwork, Output$)
  EndIf
  
  Output$ = GetOutput(LSHWPath$, "-C IO", @ExitCode, 1)
  If (Output$ <> "")
    SetGadgetText(#EditorIO, Output$)
  EndIf
  
  ProcedureReturn 1
  
EndProcedure

Procedure.s GetSystemBrowser()
  Define Browser$
  
  Browser$ = GetOutput(#SystemInfo_Which, "firefox", 0)
  
  ProcedureReturn Browser$
EndProcedure

LoadFont(#Font_Window_0_0,"Gentium", 15)

Result = CatchImage(#PB_Any, ?Logo, ?LogoEnd - ?Logo)

If (Result <> 0)
  LogoID = ImageID(Result)
  ; we don't free the loaded image after setting the gadget, for safety reasons. It should'nt matter much anyway
  ; i guess it depends of the display/window manager if this "could" give trouble in some cases, better safe then sorry :)
EndIf

OpenMainWindow()
If (IsWindow(#MainWindow) <> 0)
  SetGadgetState(#LogoImage, LogoID)

  GuiClient_Init()
  FillHardwareTabs()
  
  InstallDir$ = GetCurrentDirectory()
  Textmode$ = InstallDir$ + "textmode"
  FileStatus = FileSize("textmode.txt")
  InputSource = -1
  If (FileStatus <= 0)
    If (FileSize(Textmode$) > 0)
      InputSource = 2
      RunResult = RunProgram(Textmode$, "tell all", "", #PB_Program_Open | #PB_Program_Read | #PB_Program_Ascii)
      If (RunResult = 0)
        OpenConsole()
        PrintN("error, could'nt launch '" + Textmode$ + "'.")
        End 332
      EndIf
    Else
      OpenConsole()
      PrintN("error, could'nt find '" + Textmode$ + "'.")
      End 332
    EndIf
  Else
    InputSource = 1
    InfoFileID = ReadFile(#PB_Any, "textmode.txt", #PB_Ascii)
  EndIf
  
  If (InputSource < 1)
    End 334
  EndIf
  
    LineNum = 1
    Done = 0
    While (Done = 0) 
      Select InputSource
        Case 1 ; read the next line of "textmode.txt"
          If (Eof(InfoFileID) <> 0)
            Done = 1
          Else
            Line$ = ReadString(InfoFileID)    ; display line by line in the debug window
          EndIf
          
        Case 2
          If (ProgramRunning(RunResult))
            If AvailableProgramOutput(RunResult)
              Line$ = ReadProgramString(RunResult)
            EndIf
          Else
            Done = 1
          EndIf
      EndSelect
      
      If (done = 0)
        Line$ = Trim(Line$)
        TokenField$ = StringField(Line$, 1, " = ")
;        ValueField$ = TokenField$
        ValueField$ = Trim(StringField(Line$, 2, " = "))
  ;      Debug "Got " + TokenField$ + " with " + ValueField$
        Select TokenField$
          Case "Name"
            SetGadgetText(#FieldValue1, ValueField$)
          Case "Version"
            SetGadgetText(#FieldValue2, ValueField$)
          Case "ID"
            SetGadgetText(#FieldValue3, ValueField$)
          Case "ID Like"
            SetGadgetText(#FieldValue4, ValueField$)
          Case "PrettyName"
            SetGadgetText(#FieldValue5, ValueField$)
          Case "URL"
            SetGadgetText(#HomepageURL, ValueField$)
          Case "Code Name"
            SetGadgetText(#FieldValue7, ValueField$)
          Case "Package Manager"
            PackageManager$ = ValueField$
            SetGadgetText(#FieldValue8, ValueField$)
          Case "IPV4"
            SetGadgetText(#FieldValue9, ValueField$)
          Case "GTK2Version"
            SetGadgetText(#FieldValue10, ValueField$)
          Case "GTK3Version"
            SetGadgetText(#FieldValue11, ValueField$)
          Case "QTVersion"
            SetGadgetText(#FieldValue12, ValueField$)
          Case "VersionID"
            SetGadgetText(#FieldValue13, ValueField$)
          Case "Ubuntu Name"
            ; we really dont want another field just saying that this is ubuntu ...
          Default
            If (Line$ <> "")
              Debug "Unhandled tokenfield '" + TokenField$ + "' from line '" + Line$ + "'"
            EndIf
        EndSelect
        LineNum + 1
        If (linenum > 5000)
          If (InfoFileID <> 0)
            CloseFile(InfoFileID)
            InfoFileID = 0
          EndIf
          MessageRequester("Fatal error", "something went terribly wrong!" + Chr(10) + "emergency exit")
          End 666
        EndIf
      EndIf
   Wend
   
  If ((InputSource = 1) And (InfoFileID <> 0))
    CloseFile(InfoFileID)
    InfoFileID = 0
  EndIf
  
  ; https://askubuntu.com/questions/5417/how-to-get-the-gpu-info
  
  quitMainForm = 0
  Repeat

    EventID  =WaitWindowEvent()
    MenuID   =EventMenu()
    GadgetID =EventGadget()
    WindowID =EventWindow()

    Select EventID
      Case #PB_Event_CloseWindow
        Select WindowID
          Case #MainWindow
            quitMainForm=1
        EndSelect


      Case #PB_Event_Gadget
        Select GadgetID
          Case #HomepageURL
;            EVType = EventType()
;            Debug "url clicked : " + EVType + " / " + Str(#PB_EventType_LeftClick)
            RunProgram(GetSystemBrowser(), GetGadgetText(#HomepageURL), "")
            
          Case #LogoImage
            Select EventType()
              Case #PB_EventType_LeftDoubleClick
              Case #PB_EventType_RightDoubleClick
              Case #PB_EventType_RightClick
              Default
            EndSelect
          Case #OKButton
            quitMainForm = 1
        EndSelect

    EndSelect
  Until quitMainForm
  CloseWindow(#MainWindow)
EndIf
End
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; CursorPosition = 416
; FirstLine = 391
; Folding = --
; EnableXP